"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.App = void 0;
const future_1 = require("../internal/future");
class App {
    constructor(config) {
        this.config = config;
    }
    render(req) {
        const tmplFuture = this.config.template().fetch(req.template);
        const i18nFuture = this.config.i18n().fetch(req.lang);
        const toOutput = (content, subject) => ({
            content,
            subject,
        });
        const getContentAndSubject = (template, i18n) => {
            const contentFuture = template.getContent(i18n, req.context);
            const subjectFuture = template.getSubject(i18n, req.context);
            return future_1.Future.equip(contentFuture).map2(subjectFuture, toOutput).inner;
        };
        return future_1.Future.equip(tmplFuture).andThen2(i18nFuture, getContentAndSubject)
            .inner;
    }
    send(req) {
        const transport = this.config.transport();
        return future_1.Future.equip(this.render(req))
            .map(({ content, subject }) => ({
            message: content,
            recipient: req.recipient,
            sender: req.sender,
            subject,
        }))
            .andThen((req) => transport.send(req)).inner;
    }
}
exports.App = App;
//# sourceMappingURL=impl.js.map