"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeI18nPoContainer = exports.I18nPoFileSource = void 0;
const fail_1 = require("../internal/fail");
const future_1 = require("../internal/future");
const source_1 = require("../source");
const container_1 = require("./container");
const PoFile = __importStar(require("./file-po"));
class I18nPoFileSource {
    constructor(cache, source) {
        this.cache = cache;
        this.source = source;
    }
    static make(config) {
        const transform = (path, name) => path.join(`${name}/backtrace_hermes.po`);
        return future_1.Future.equip(source_1.FileSystem.make(config.path, config.fileSystem, transform))
            .mapErr((err) => new fail_1.FailUnknown(err))
            .map((source) => new I18nPoFileSource(config.cache, source)).inner;
    }
    fetch(key) {
        const cache = this.cache;
        const cachedItem = cache.get(key);
        if (cachedItem != null) {
            return future_1.Future.resolve(cachedItem).inner;
        }
        const cacheItem = (item) => {
            cache.add(key, item);
            return item;
        };
        const parseFile = (contents) => {
            return future_1.Future.equip(PoFile.parse(key, contents)).mapErr((err) => err.getMessage()).inner;
        };
        return future_1.Future.equip(this.source.fetch(key))
            .andThen(parseFile)
            .map(cacheItem).inner;
    }
}
exports.I18nPoFileSource = I18nPoFileSource;
function makeI18nPoContainer(config) {
    return future_1.Future.equip(I18nPoFileSource.make(config))
        .mapErr((fail) => fail.getMessage())
        .map((source) => new container_1.Container(config.renderConstructor, source)).inner;
}
exports.makeI18nPoContainer = makeI18nPoContainer;
//# sourceMappingURL=source-file-po.js.map