"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const ipResolver_1 = require("./ipResolver");
(0, ava_1.default)('Validate localhost access', (executionContext) => {
    const ipResolver = new ipResolver_1.IpAddressResolver([]);
    const whiteListResult = ipResolver.isWhiteListed('127.0.0.1');
    executionContext.is(whiteListResult, true);
});
(0, ava_1.default)('Validate localhost host with v6 ip address', (executionContext) => {
    const ipResolver = new ipResolver_1.IpAddressResolver([]);
    const v6IpAddress = '::ffff:127.0.0.1';
    const whiteListResult = ipResolver.isWhiteListed(v6IpAddress);
    executionContext.is(whiteListResult, true);
});
(0, ava_1.default)('Validate remote ip address with whitelist array', (executionContext) => {
    const whitelistedIpAddress = '1.2.3.4';
    const ipResolver = new ipResolver_1.IpAddressResolver([whitelistedIpAddress]);
    const whiteListResult = ipResolver.isWhiteListed(whitelistedIpAddress);
    executionContext.is(whiteListResult, true);
});
(0, ava_1.default)('Validate remote ip address that is not available in the whitelist array', (executionContext) => {
    const whitelistedIpAddress = '1.2.3.4';
    const ipResolver = new ipResolver_1.IpAddressResolver([]);
    const whiteListResult = ipResolver.isWhiteListed(whitelistedIpAddress);
    executionContext.is(whiteListResult, false);
});
//# sourceMappingURL=ipAddressResolver.spec.js.map