"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IpAddressResolver = void 0;
class IpAddressResolver {
    constructor(_whitelistedIpAddresses) {
        this._whitelistedIpAddresses = _whitelistedIpAddresses;
        this._localhost = '127.0.0.1';
    }
    isWhiteListed(ip) {
        if (!ip) {
            return undefined;
        }
        if (ip.includes('::ffff:')) {
            ip = ip.split(':').reverse()[0];
        }
        const ipv6LocalhostAddresses = [
            '::1',
            '0:0:0:0:0:0:0:1',
            '0000:0000:0000:0000:0000:0000:0000:0001',
        ];
        const isLocalAddress = ipv6LocalhostAddresses.some(n => n === ip) || ip === this._localhost;
        if (isLocalAddress) {
            return true;
        }
        return this._whitelistedIpAddresses.some((ipAddress) => ipAddress === ip);
    }
}
exports.IpAddressResolver = IpAddressResolver;
//# sourceMappingURL=ipResolver.js.map