"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transport = void 0;
const nodemailer = __importStar(require("nodemailer"));
const rustic_1 = require("rustic");
class Transport {
    constructor(config) {
        this.transport = nodemailer.createTransport({
            host: config.host,
            port: (0, rustic_1.equip)(config.port).unwrapOr(587),
            secure: (0, rustic_1.equip)(config.secure).unwrapOr(false),
            auth: config.auth,
        });
    }
    send(envelope) {
        return new Promise((resolve, _ignored) => {
            const email = Transport.envelopeToOptions(envelope);
            const resolver = Transport.makeReplyResolver(resolve);
            this.transport.sendMail(email, resolver);
        });
    }
    static makeReplyResolver(resolve) {
        return (err, info) => {
            resolve(err == null
                ? (0, rustic_1.Ok)(Transport.sentMessageIntoReply(info))
                : (0, rustic_1.Err)(JSON.stringify(err)));
        };
    }
    static envelopeToOptions(envelope) {
        return {
            from: envelope.sender,
            to: envelope.recipient,
            subject: envelope.subject,
            html: envelope.message,
        };
    }
    static sentMessageIntoReply(msg) {
        return {
            ...msg,
            previewUrl: nodemailer.getTestMessageUrl(msg),
            success: msg.response.startsWith('250 Accepted'),
            status: msg.response,
        };
    }
}
exports.Transport = Transport;
//# sourceMappingURL=index.js.map