#!/usr/bin/env bash

# Usage (from the project root folder)
#   ./scripts/tag.sh 0.0.9
# This script:
#  1. bumps the version within package.json
#  2. commits that with commit msg "Release $version"
#  3. pushes up that commit and tag to the remote repository (origin/master)

sed -i "s/\"version\":.*/\"version\": \"${1}\",/" package.json
git add package.json
git commit -m "Release $1"
git tag "release/$1"
git push origin master
git push origin --tags
